/*
   Copyright (c) 2014-2019 by Plexim GmbH
   All rights reserved.

   A free license is granted to anyone to use this software for any legal
   non safety-critical purpose, including commercial applications, provided
   that:
   1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
   2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
 */

#include "includes.h"
#include "pil.h"

#include "gatedriver.h"
#include "pwm.h"

#ifndef PWR_H_
#define PWR_H_

#include "power_impl.h"

extern void PWR_sinit();

extern void PWR_configure(GDRV_Handle_t aGateDrvHandle, uint16_t aFsmExecRateHz);
extern void PWR_unregisterAllPwmChannels();
extern void PWR_registerPwmChannel(PWM_Handle_t aChannel);
extern void PWR_configureTZGpio(uint16_t aTzId, uint16_t aGpio);

extern void PWR_fsm(); // call from infrastructure thread
extern void PWR_background(); // call from background thread
extern void PWR_syncEnableSwitching(); // call from control thread

extern void PWR_setPilMode(bool pilMode);  // OK to call from any thread
extern bool PWR_isReadyForEnable(); // OK to call from any thread
extern void PWR_enable(bool aEnable); // OK to call from any thread
extern bool PWR_isEnabled(); // OK to call from any thread

#endif /* PWR_H_ */
